# This file was auto-generated by Fern from our API Definition.

import datetime as dt
import typing

from ...core.datetime_utils import serialize_datetime
from ...core.pydantic_utilities import deep_union_pydantic_dicts, pydantic_v1


class StsTransferApi(pydantic_v1.BaseModel):
    """
    STS asset transfer API.
    """

    aws_access_key_id: str = pydantic_v1.Field()
    """
    AWS access key. Used for asset transfer.
    """

    aws_region: str = pydantic_v1.Field()
    """
    AWS region. Used for asset transfer.
    """

    aws_secret_access_key: str = pydantic_v1.Field()
    """
    AWS secret access key.
    """

    aws_session_token: typing.Optional[str] = pydantic_v1.Field(default=None)
    """
    AWS session token. Used for asset transfer.
    """

    s3bucket: str = pydantic_v1.Field(alias="s3_bucket")
    """
    S3 bucket. Used for asset transfer.
    """

    s3endpoint_url: typing.Optional[str] = pydantic_v1.Field(alias="s3_endpoint_url", default=None)
    """
    S3 endpoint URL. Used for asset transfer.
    """

    s3key: str = pydantic_v1.Field(alias="s3_key")
    """
    S3 key. Used for asset transfer.
    """

    s3url: str = pydantic_v1.Field(alias="s3_url")
    """
    S3 full URL. Used for asset transfer.
    """

    def json(self, **kwargs: typing.Any) -> str:
        kwargs_with_defaults: typing.Any = {"by_alias": True, "exclude_unset": True, **kwargs}
        return super().json(**kwargs_with_defaults)

    def dict(self, **kwargs: typing.Any) -> typing.Dict[str, typing.Any]:
        kwargs_with_defaults_exclude_unset: typing.Any = {"by_alias": True, "exclude_unset": True, **kwargs}
        kwargs_with_defaults_exclude_none: typing.Any = {"by_alias": True, "exclude_none": True, **kwargs}

        return deep_union_pydantic_dicts(
            super().dict(**kwargs_with_defaults_exclude_unset), super().dict(**kwargs_with_defaults_exclude_none)
        )

    class Config:
        frozen = True
        smart_union = True
        allow_population_by_field_name = True
        populate_by_name = True
        extra = pydantic_v1.Extra.allow
        json_encoders = {dt.datetime: serialize_datetime}
