# This file was auto-generated by Fern from our API Definition.

import datetime as dt
import typing

from ...core.datetime_utils import serialize_datetime
from ...core.pydantic_utilities import deep_union_pydantic_dicts, pydantic_v1
from .chat_completion_chunk_choice import ChatCompletionChunkChoice
from .usage_stats import UsageStats


class ChatCompletionChunk(pydantic_v1.BaseModel):
    """
    Represents a single chunk of a streaming chat completion response.

    This object's schema is compatible with OpenAI's Chat Completion API.
    """

    choices: typing.List[ChatCompletionChunkChoice] = pydantic_v1.Field()
    """
    A list of chat completion choices.Can be more than one if n is greater than 1.
    """

    created: int = pydantic_v1.Field()
    """
    The Unix timestamp (in seconds) of when the chat completion was created.
    """

    id: str = pydantic_v1.Field()
    """
    A unique identifier for the entire chat completion request. Each chunk in the stream has the same ID.
    """

    model: str = pydantic_v1.Field()
    """
    The model used for the chat completion.
    """

    object: typing.Optional[typing.Literal["chat.completion.chunk"]] = pydantic_v1.Field(default=None)
    """
    Object type field which is a constant and preset.
    """

    usage: typing.Optional[UsageStats] = None

    def json(self, **kwargs: typing.Any) -> str:
        kwargs_with_defaults: typing.Any = {"by_alias": True, "exclude_unset": True, **kwargs}
        return super().json(**kwargs_with_defaults)

    def dict(self, **kwargs: typing.Any) -> typing.Dict[str, typing.Any]:
        kwargs_with_defaults_exclude_unset: typing.Any = {"by_alias": True, "exclude_unset": True, **kwargs}
        kwargs_with_defaults_exclude_none: typing.Any = {"by_alias": True, "exclude_none": True, **kwargs}

        return deep_union_pydantic_dicts(
            super().dict(**kwargs_with_defaults_exclude_unset), super().dict(**kwargs_with_defaults_exclude_none)
        )

    class Config:
        frozen = True
        smart_union = True
        extra = pydantic_v1.Extra.allow
        json_encoders = {dt.datetime: serialize_datetime}
